/**
 * LogHandler.java
 * Created on 18.12.2003 by sr
 *
 * (C) 2002, 2003 by Rinke Solutions, all Rights reserved.
 *
 * Diese Software enthaelt vertrauliche Informationen der Rinke Solutions.
 * Eine Weitergabe dieser Software oder der Informationen als Ganzes oder 
 * in Teilen an Dritte ist nicht gestattet.
 * Die Benutzung darf nur im Rahmen der mit der Rinke Solutions vereinbarten 
 * Bedingungen erfolgen.
 *
 * JEDWEDE GEWAEHRLEISTUNGSANSPRUECHE WEGEN EVENTUELLER MAENGEL AN DER 
 * SOFTWARE SIND, SOWEIT GESETZLICH ZULAESSIG, AUSGESCHLOSSEN. ES WIRD WEDER 
 * GARANTIE NOCH JURISTISCHE VERANTWORTUNG ODER IRGENDEINE HAFTUNG FUER FOLGEN,
 * DIE AUF FEHLERHAFTE ANGABEN, BENUTZUNG ODER FEHLFUNKTIONEN DER SOFTWARE 
 * SELBST ZURUECKGEHEN, UEBERNOMMEN.
 * DER HERSTELLER HAFTET IN KEINEM FALL FUER SCHAEDEN (Z.B. GEWINNVERLUSTE,
 * BETRIEBSUNTERBRECHUNG ODER VERLUSTE VON GESCHAEFTSINFORMATIONEN), 
 * DIE AUFGRUND DER VERWENDUNG ODER DER NICHTANWENDBARKEIT DER SOFTWARE 
 * ODER DER BEGLEITENDEN DOKUMENTATION ENTSTEHEN.
 *
 * $Id: $
 */
// taken from axis samples: package samples.userguide.example4;

package de.rinke.solutions.handler;

import org.apache.axis.AxisFault;
import org.apache.axis.Handler;
import org.apache.axis.MessageContext;
import org.apache.axis.handlers.BasicHandler;

import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Date;

/**
 * @axis.handler name="track"
 * @axis.parameter name="filename" value="test.log"
 * @author sr
 *
 */
public class LogHandler extends BasicHandler {
	public void invoke(MessageContext msgContext) throws AxisFault
	{
		/** Log an access each time we get invoked.
		 */
		try {
			Handler serviceHandler = msgContext.getService();
			String filename = (String)getOption("filename");
			if ((filename == null) || (filename.equals("")))
				throw new AxisFault("Server.NoLogFile",
								 "No log file configured for the LogHandler!",
									null, null);
			FileOutputStream fos = new FileOutputStream(filename, true);
            
			PrintWriter writer = new PrintWriter(fos);
            
			Integer numAccesses =
							 (Integer)serviceHandler.getOption("accesses");
			if (numAccesses == null)
				numAccesses = new Integer(0);
            
			numAccesses = new Integer(numAccesses.intValue() + 1);
            
			Date date = new Date();
			String result = date + ": service " +
							msgContext.getTargetService() +
							" accessed " + numAccesses + " time(s).";
			serviceHandler.setOption("accesses", numAccesses);
            
			writer.println(result);
            
			writer.close();
		} catch (Exception e) {
			throw AxisFault.makeFault(e);
		}
	}
}
